#version 300 es
precision mediump float;
uniform mat4 mv_matrix;
uniform mat4 proj_matrix;

in vec3 v_normal;
in lowp float SpecularIntensity;
in vec3 v_eyeDirectModel;

out vec4 outColor;

uniform sampler2D t_texture0;

const lowp float eta = 0.65;
void main() {
    // Calculate refraction direction in model space
    vec3 refractDirect = refract(v_eyeDirectModel, normalize(v_normal), eta);
    // Project refraction
    refractDirect = (proj_matrix * mv_matrix * vec4(refractDirect, 0.0)).xyw;
    // Map refraction direction to 2d coordinates
    vec2 refractCoord = 0.5 * (refractDirect.xy / refractDirect.z) + 0.5;

    vec4 glassColor = texture(t_texture0, refractCoord) + SpecularIntensity;
    glassColor.a *= 0.1; // transparent
    outColor = glassColor;
}