#version 300 es
uniform mat3 normal_matrix;
uniform mat4 mv_matrix;
uniform mat4 proj_matrix;
uniform vec3 u_lightdir;
uniform vec3 u_eyedir;
uniform vec4 u_color;
uniform float u_pol; // Interpolation percentage, unit length

in vec4 a_vertex;
in vec4 a_vertex2;
in vec3 a_normal;
in vec3 a_normal2;
in vec2 a_texcoord0;
in vec4 a_color;

out vec2 v_texcoord0;
out vec3 v_viewDir;
out vec3 v_lightDir;
out vec3 v_normal;
out vec4 v_color;

void main( void )
{
    vec4 fvObjectPosition = proj_matrix * mv_matrix * mix(a_vertex, a_vertex2, u_pol);

    v_viewDir  = u_eyedir;
    v_lightDir = u_lightdir;

    v_normal         = normalize(normal_matrix * mix(a_normal, a_normal2, u_pol));
    v_color = u_color * a_color;
    v_texcoord0    = a_texcoord0.xy;
    gl_Position = fvObjectPosition;
}