#version 300 es
precision mediump float;
uniform vec4 u_ambient;
uniform vec4 u_specular;
uniform vec4 u_diffuse;
uniform float u_specularpower;

uniform sampler2D t_texture0;

in vec2 v_texcoord0;
in vec3 v_viewDir;
in vec3 v_lightDir;
in vec3 v_normal;
in vec4 v_color;

out vec4 outColor;

float mysmoothstep(float edge0, float edge1, float x)
{
    float t = clamp((x - edge0) / (edge1 - edge0), 0.0, 1.0);
    return t * t * (3.0 - 2.0 * t);
}

void main( void )
{
    float fNDotL           = dot( v_normal, v_lightDir ); 

    float toon = 0.5 * mysmoothstep(0.56, 0.57, fNDotL) + 0.5;

    vec3  fvReflection     = normalize( ( ( 1.0 * v_normal ) * fNDotL ) - v_lightDir );
   
    vec4  fvBaseColor      = v_color * texture(t_texture0, v_texcoord0 );

    vec4  fvTotalDiffuse   = vec4((u_diffuse * fNDotL).xyz, 1.0);
    vec4  fvTotalSpecular  = u_specular * ( pow( max( 0.0, dot( fvReflection, v_viewDir ) ), u_specularpower ) );

    fvTotalDiffuse *= toon;

    outColor = vec4(( (u_ambient + fvTotalDiffuse + fvTotalSpecular) * fvBaseColor ).xyz, v_color.w); 
}