#version 300 es
uniform mat4 mv_matrix;
uniform mat4 proj_matrix;
uniform mat4 mvp_lightMatrix;
uniform vec4 u_color;
uniform float u_pol; // Interpolation percentage, unit length

in vec4 a_vertex;
in vec4 a_vertex2;
in vec2 a_texcoord0;
in vec4 a_color;

out vec4 v_color;
out vec2 v_texcoord0;
out vec4 v_shadowCoord;

void main(void)
{
    v_color = u_color * a_color;
    v_texcoord0 = a_texcoord0;
    vec4 lerped = mix(a_vertex, a_vertex2, u_pol);

    v_shadowCoord = mvp_lightMatrix * lerped;

    gl_Position = proj_matrix * mv_matrix * lerped;
}