#version 300 es
precision mediump float;
uniform vec4 u_ambient;
uniform vec4 u_specular;
uniform vec4 u_diffuse;
uniform float u_specularpower;

uniform sampler2D t_texture0;

in vec2 v_texcoord0;
in vec3 v_viewDir;
in vec3 v_lightDir;
in vec3 v_normal;
in vec4 v_color;

out vec4 outColor;

void main( void )
{
    vec4  fvBaseColor = texture( t_texture0, v_texcoord0 );

    if (fvBaseColor.a < 0.95)
        discard;

    float fNDotL           = dot( v_normal, v_lightDir ); 
    vec3  fvReflection     = normalize( ( ( 2.0 * v_normal ) * fNDotL ) - v_lightDir );

    vec4  fvTotalDiffuse   = vec4((u_diffuse * fNDotL).xyz, 1.0);
    vec4  fvTotalSpecular  = u_specular * ( pow( max( 0.0, dot( fvReflection, v_viewDir ) ), u_specularpower ) );

    outColor = vec4(( (u_ambient + fvTotalDiffuse + fvTotalSpecular) * fvBaseColor ).xyz, v_color.w); 
}