#version 300 es
precision mediump float;
uniform mat4 mv_matrix;
uniform mat4 proj_matrix;

in vec4 a_vertex;
in vec3 a_normal;

out vec3 v_normal;
out vec3 v_eyeDirectModel;

void main() {
    vec4 eyePositionModel = mv_matrix * a_vertex;
    // Eye direction in model space
    vec3 eyeDirectModel = normalize(- eyePositionModel.xyz);

    v_normal = normalize(vec3(mv_matrix * vec4(a_normal, 0.0)));
    gl_Position = proj_matrix * mv_matrix * a_vertex;
}