#version 300 es
precision mediump float;
precision mediump sampler2DShadow;

uniform sampler2D t_texture0;
uniform sampler2DShadow s_shadowMap;

in vec2 v_texcoord0;
in vec4 v_color;
in vec4 v_shadowCoord;

out vec4 outColor;

void main(void)
{
    vec4 color = texture(t_texture0, v_texcoord0);

    if (color.a < 0.95)
        discard;

    // calculate shadow
    float shadow = textureProj(s_shadowMap, v_shadowCoord);
    shadow = mix(0.5, 1.0, shadow);

    outColor = vec4(shadow, shadow, shadow, 1.0) * color * v_color;
}