#version 300 es
precision mediump float
uniform sampler2D t_texture0;
uniform sampler2D t_texture1;

in vec2 v_texcoord0;
in vec4 v_color;

out vec4 outColor;

void main(void)
{
    mediump vec3 yuv;
    lowp vec3 rgb;

    yuv.x = texture(t_texture0, v_texcoord0).r;
    yuv.yz = texture(t_texture1, v_texcoord0).rg - vec2(0.5, 0.5);

    // Using BT.709 which is the standard for HDTV
    rgb = mat3(      1,       1,      1,
                     0, -.18732, 1.8556,
               1.57481, -.46813,      0) * yuv;

    outColor = vec4(rgb, 1) * v_color;
}
