#version 300 es
precision mediump float;
uniform sampler2D t_texture0;
uniform sampler2D t_texture1;

in vec2 v_texcoord0;
in vec2 v_texcoord1;
in vec4 v_color;
in float v_eyeDist;

out vec4 outColor;

float computeLinearFogFactor()
{
    float u_fogMaxDist = 200.0;
    float u_fogMinDist = 50.0;
    float factor;
   
    // Compute linear fog equation
    factor = (u_fogMaxDist - v_eyeDist) /
             (u_fogMaxDist - u_fogMinDist );
   
    // Clamp in the [0,1] range
    factor = clamp( factor, 0.0, 1.0 );
            
    return factor;            
}

void main(void)
{
    float fogFactor = 1.0 - computeLinearFogFactor();
    vec4 fogColor = fogFactor * vec4(0.8, 0.5, 0.20, 1.0);
    vec4 fvBaseColor = v_color * texture(t_texture0, v_texcoord0) * (texture(t_texture1, v_texcoord1) + 0.2);

    outColor = vec4(mix(fvBaseColor, fogColor, fogFactor).rgb, 1.0);
//    outColor = vec4((fvBaseColor + (fogColor * fogFactor)).rgb, 1.0);
}
