#version 300 es
uniform mat4 mv_matrix;
uniform mat4 proj_matrix;
uniform vec4 u_color;
uniform vec3 u_eyepos;

in vec3 a_vertex;
in vec2 a_texcoord0;
in vec2 a_texcoord1;
in vec4 a_color;

out vec4 v_color;
out vec2 v_texcoord0;
out vec2 v_texcoord1;
out float v_eyeDist;

void main(void)
{
    v_color = u_color * a_color;
    vec4 fvObjectPosition = (vec4(a_vertex, 1.0)); // NOTE: Normally you'd multiply by the model matrix here, but we only have modelVIEW.

    v_eyeDist = sqrt( (fvObjectPosition.x - u_eyepos.x) * (fvObjectPosition.x - u_eyepos.x)
                    + (fvObjectPosition.y - u_eyepos.y) * (fvObjectPosition.y - u_eyepos.y)
                    + (fvObjectPosition.z - u_eyepos.z) * (fvObjectPosition.z - u_eyepos.z) );

    gl_Position = proj_matrix * mv_matrix * fvObjectPosition;

    v_texcoord0 = a_texcoord0;
    v_texcoord1 = a_texcoord1;
}