QueueCommand("cam_height 64")
QueueCommand("cam_dist 384")

function ThinkForBlock1a(block)
    startPos = Vector.new(-2928, 288, 8544)
    endPos = Vector.new(-2448, 288, 8304)
    Vector.Mul(startPos, WUNITS, startPos)
    Vector.Mul(endPos, WUNITS, endPos)
    WObjThinker.TranslateToDest(block, CurveType.QuadraticEaseInOut, Vector.Distance(startPos, endPos) / 5, endPos, block).blocking = true
    WObjThinker.Wait(block, 1, ThinkForBlock1b)
    return true
end

function ThinkForBlock1b(block)
    startPos = Vector.new(-2928, 288, 8544)
    endPos = Vector.new(-2448, 288, 8304)
    Vector.Mul(startPos, WUNITS, startPos)
    Vector.Mul(endPos, WUNITS, endPos)
    WObjThinker.TranslateToDest(block, CurveType.QuadraticEaseInOut, Vector.Distance(startPos, endPos) / 5, startPos, block).blocking = true
    WObjThinker.Wait(block, 1, ThinkForBlock1a)
    return true
end

function ThinkForBlock2a(block)
    startPos = Vector.new(-1856, 480, 8832)
    midPos = Vector.new(-1856, 320, 8832)
    endPos = Vector.new(-2144, 320, 8352)
    Vector.Mul(startPos, WUNITS, startPos)
    Vector.Mul(midPos, WUNITS, midPos)
    Vector.Mul(endPos, WUNITS, endPos)
    WObjThinker.TranslateToDest(block, CurveType.QuadraticEaseInOut, Vector.Distance(startPos, midPos) / 2.5, midPos, block).blocking = true
    WObjThinker.RotateToDest(block, CurveType.QuadraticEaseInOut, 45/2.5, block.up, 45, block, block.angle)
    block.pos.x = midPos.x
    block.pos.y = midPos.y
    block.pos.z = midPos.z
    WObjThinker.TranslateToDest(block, CurveType.QuadraticEaseInOut, Vector.Distance(midPos, endPos) / 5, endPos, block).blocking = true
    WObjThinker.Wait(block, 1, ThinkForBlock2b)
    block.pos.x = startPos.x
    block.pos.y = startPos.y
    block.pos.z = startPos.z
    return true
end

function ThinkForBlock2b(block)
    startPos = Vector.new(-1856, 480, 8832)
    midPos = Vector.new(-1856, 320, 8832)
    endPos = Vector.new(-2144, 320, 8352)
    Vector.Mul(startPos, WUNITS, startPos)
    Vector.Mul(midPos, WUNITS, midPos)
    Vector.Mul(endPos, WUNITS, endPos)
    WObjThinker.RotateToDest(block, CurveType.QuadraticEaseInOut, 45/2.5, block.up, -45, block, block.angle)
    WObjThinker.TranslateToDest(block, CurveType.QuadraticEaseInOut, Vector.Distance(endPos, midPos) / 2.5, midPos, block).blocking = true
    block.pos.x = midPos.x
    block.pos.y = midPos.y
    block.pos.z = midPos.z
    WObjThinker.TranslateToDest(block, CurveType.QuadraticEaseInOut, Vector.Distance(midPos, startPos) / 5, startPos, block).blocking = true
    WObjThinker.Wait(block, 1, ThinkForBlock2a)
    block.pos.x = endPos.x
    block.pos.y = endPos.y
    block.pos.z = endPos.z
    return true
end

function Sparkle_Rotate(object)
---    WObjThinker.RotateToDest(object, CurveType.LinearInterpolation, 60, object.up, 360, object, object.angle)
    WObjThinker.RotateToDest(object, CurveType.LinearInterpolation, 60, object.angle, 360, object, object.up).blocking = true
    WObjThinker.Wait(object, 0, Sparkle_Rotate) -- Calls itself to restart after the rotation is completed
    return true
end

function Windmill_Rotate(object)
    WObjThinker.RotateToDest(object, CurveType.LinearInterpolation, 60, object.angle, 360, object, object.up).blocking = true
    WObjThinker.Wait(object, 0, Windmill_Rotate) -- Calls itself to restart after the rotation is completed
    return true
end

function Windmill_PostThink(wobj)
    -- This is needed to fix the side angle vector in the transformation matrix every tic
    Vector.Cross(wobj.up, wobj.angle, wobj.side)
end

world = World.Get()
skybox = world.skyBox

windmill = skybox:FindWObjWithTag(1)
if (windmill ~= nil)
then
    Windmill_Rotate(windmill)
    windmill:AddPostThinker(Windmill_PostThink)
end

windmill = skybox:FindWObjWithTag(2)
if (windmill ~= nil)
then
    Windmill_Rotate(windmill)
    windmill:AddPostThinker(Windmill_PostThink)
end

sparkle = skybox:FindWObjWithTag(3)
if (sparkle ~= nil)
then
    Sparkle_Rotate(sparkle)
    sparkle:AddPostThinker(Windmill_PostThink)
end

function string.starts(String,Start)
   return string.sub(String,1,string.len(Start))==Start
end

function Water_Animate()
    world = World.Get()
    if (world.leveltime % 8 ~= 0)
    then
        return
    end

    waterObj = WObj.FindNextWithTag(nil, 45)
    while (waterObj ~= nil)
    do
        model = waterObj.model

        numMaterials = model.numMaterials

        for i = 0, numMaterials - 1, 1
        do
            material = model:GetMaterial(i)

            if (material.baseColor ~= nil and string.starts(material.baseColor, "textures/xmas/FWATER"))
            then
                material.shaderProgram = "1texture_water.vert,1texture_water.frag"
--                skiplen = string.len("textures/xmas/FWATER") + 1
--                waterNum = tonumber(string.sub(material.baseColor, skiplen, skiplen + 1))
--                waterNum = waterNum + 1
--                if (waterNum > 16)
--                then
--                    waterNum = 1
--                end
--                newTexName = "textures/xmas/FWATER" .. string.format("%d", waterNum) .. ".buz"
--                material.baseColor = newTexName
            elseif (material.baseColor ~= nil and string.starts(material.baseColor, "textures/xmas/CFALL"))
            then
                material.shaderProgram = "1texture_waterfall.vert,1texture_waterfall.frag"
            end
        end
        waterObj = WObj.FindNextWithTag(waterObj, 45)
    end
    
end

function Splash_Think(object)
    curTimer = object:GetVarNumeric("SplashTimer")
    if curTimer == 0
    then
        curTimer = RandomRange(8, 24)
        splash = WObj.Spawn(10, object.pos, object.up, object.angle)
        splash.scale = 3
        if RandomRange(0, 1) == 1
        then
            splash:SetAnimation("Splash2")
        end
    else
        curTimer = curTimer - 1
    end
    object:SetVar("SplashTimer", curTimer)
end

function Ring_Rotate(object)
    rotateAmt = (world.leveltime * 4) % 360
    object.angle.x = 1
    object.angle.y = 0
    object.angle.z = 0
    Vector.Rotate(object.angle, object.up, rotateAmt)
    Vector.Cross(object.up, object.angle, object.side)
end

function Sparkle_Fade(object)
    object.alpha = object.alpha - 0.05
    if object.alpha < 0
    then
        object:Remove()
    end
end

function playerHitObj(player, hitObject)
    if (hitObject.type == 5400)
    then
        angle = 0
        for i = 0, 3, 1
        do
            debris = WObj.Spawn(5401, hitObject.pos, hitObject.up, hitObject.angle)
            debris:AddPreThinker(Sparkle_Fade)
            debris.pos.x = debris.pos.x + RandomFloat(-0.5, 0.5)
            debris.pos.y = debris.pos.y + RandomFloat(-0.5, 0.5)
            debris.pos.z = debris.pos.z + RandomFloat(-0.5, 0.5)
            debris.scale = RandomFloat(0.1, 0.5)
        end

        hitObject:Remove()
        player.obj:StartSound("srb/ring")
    elseif (hitObject.type == 999)
    then
        angle = 0
        for i = 0, 3, 1
        do
            debris = WObj.Spawn(5401, hitObject.pos, hitObject.up, hitObject.angle)
            debris:AddPreThinker(Sparkle_Fade)
            debris.pos.x = debris.pos.x + RandomFloat(-0.5, 0.5)
            debris.pos.y = debris.pos.y + RandomFloat(-0.5, 0.5)
            debris.pos.z = debris.pos.z + RandomFloat(-0.5, 0.5)
            debris.scale = RandomFloat(0.1, 0.5)
        end

        hitObject:Remove()
        player.obj:StartSound("srb/soda")
    elseif (hitObject.type == 5440 or hitObject.type == 5441) -- Spring up
    then
        movedir = Vector.Strength(player.obj.mom, hitObject.up)
        springStrength = hitObject:GetVarNumeric("Strength")
print (springStrength)
        if (springStrength == nil or springStrength == 0)
        then
            springStrength = 20
        end

        if (movedir < WUNITS)
        then
            Vector.Copy(player.obj.up, hitObject.up)
            Vector.Mul(player.obj.up, springStrength * WUNITS, player.obj.mom)
            Vector.Mul(hitObject.up, hitObject.radius + player.obj.radius, player.obj.pos)
            Vector.Add(player.obj.pos, hitObject.pos, player.obj.pos)
            player.obj:RemoveActionFlag(ActionFlags.OnGround)
            player.obj.floorCount = 0
            player.obj:SetAnimation("Springing")
            player.obj:StartSound("srb/spring")
            hitObject:SetAnimation("Active")
        end
    end
end

function playerPostThink(player)
    if (player.obj.stateInfo.anim.name == "Springing" and Vector.Strength(player.obj.mom, player.obj.up) < 0)
    then
        player.obj:SetNextAnimation("Falling")
    end
end

world:AddAfterThinkHook(Water_Animate)

waterObj = WObj.FindNextWithTag(nil, 45)
while (waterObj ~= nil)
do
    waterObj:RemoveFlag(InfoFlags.OF_SOLID)
    waterObj.alpha = 0.8
    waterObj = WObj.FindNextWithTag(waterObj, 45)
end

objScan = WObj.head()
while (objScan ~= nil)
do
    if objScan.type == 5400
    then
        objScan:AddPreThinker(Ring_Rotate)
        material = objScan.model:GetMaterial(0)
        if material ~= nil
        then
            material.shaderProgram = "1texture_matcap.vert,1texture_matcap.frag"
        end
    elseif objScan.type == 999
    then
        objScan:AddPreThinker(Ring_Rotate)
    end

    objScan = objScan.next
end

splashObj = WObj.FindNextWithTag(nil, 46)
while (splashObj ~= nil)
do
    splashObj:AddPostThinker(Splash_Think)
    splashObj:SetVar("SplashTimer", RandomRange(8, 24))
    splashObj = WObj.FindNextWithTag(splashObj, 46)
end

block = WObj.FindNextWithTag(nil, 57)
if (block ~= nil)
then
    ThinkForBlock1a(block)
end

block = WObj.FindNextWithTag(nil, 58)
if (block ~= nil)
then
    ThinkForBlock2a(block)
    block:AddPostThinker(Windmill_PostThink)
end

endmarker = WObj.FindNextWithTag(nil, 4243)
endmarker:AddFlag(InfoFlags.NoDraw)

me = Player.head()
me:AddCollisionObjHook(playerHitObj)
me:AddPostThinker(playerPostThink)
